@for (attachment of attachments; track attachment) {
  <div class="attachment">
    @switch (attachment.kind) {
      @case ('persisted-attachment') {
        <div>
          <div class="row">
            <div class="cell name">
              <a
                [href]="getAttachmentDownloadURL(attachment)"
                (click)="openFilePreviewDialog($event, attachment)"
                >{{ attachment.name }}</a
              >
            </div>
            <div class="cell size">
              <span>{{ attachment.size | convertFileSize }}</span>
            </div>
            @if (canAttach && showDeleteButton) {
              <div class="cell delete" (click)="delete(attachment)">
                <span>
                  <i
                    nz-icon
                    nzType="sqtm-core-generic:delete"
                    nzTheme="outline"
                  ></i>
                </span>
              </div>
            }
          </div>
          <div class="added-on flex-row">
            <span
              >{{ 'sqtm-core.generic.date.prefix.added-on' | translate }}
              {{ attachment.addedOn | date: 'short' }}</span
            >
            @if (attachment.pendingDelete) {
              <div style="margin-left: auto">
                <button
                  class="sqtm-core-delete-button"
                  nz-button
                  nzType="primary"
                  [nzSize]="'small'"
                  (click)="confirm(attachment)"
                >
                  {{ 'sqtm-core.generic.label.delete' | translate }}
                </button>
                <button
                  class="m-l-10"
                  nz-button
                  nzType="default"
                  [nzSize]="'small'"
                  (click)="cancel(attachment)"
                >
                  {{ 'sqtm-core.generic.label.cancel' | translate }}
                </button>
              </div>
            }
          </div>
        </div>
      }
      @case ('rejected-attachment') {
        <div>
          <div class="row">
            <div class="cell name">
              <span style="color: red">{{ attachment.name }}</span>
            </div>
            <div class="cell size">
              <span>{{ attachment.size | convertFileSize }}</span>
            </div>
            <div
              class="cell delete"
              (click)="removeRejectedAttachment(attachment)"
            >
              <span>
                <i nz-icon nzType="close" nzTheme="outline"></i>
              </span>
            </div>
          </div>
          <div class="added-on flex-row">
            <span>
              <i nz-icon nzType="warning" nzTheme="outline"></i>
            </span>
            <span class="m-l-10">{{
              'sqtm-core.generic.label.rejected' | translate
            }}</span>
          </div>
          @for (error of attachment.errors; track error) {
            <div class="flex-row">
              {{ error }}
            </div>
          }
        </div>
      }
      @case ('uploading-attachment') {
        <div>
          <div class="row">
            <div class="cell name">
              <span style="color: grey">{{ attachment.name }}</span>
            </div>
            <div class="cell size">
              <span>{{ attachment.size | convertFileSize }}</span>
            </div>
          </div>
          <div class="row full-width">
            <nz-progress
              class="full-width"
              [nzPercent]="attachment.uploadProgress"
            ></nz-progress>
          </div>
        </div>
      }
    }
  </div>
}
